# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2004 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _extract.awk,v 1.1 2004/08/08 21:15:38 carlo Exp $
# =====================================================================
# int _extract(string s, pattern p)
#
# Extract the portion of a string matching a pattern. The matching
# pattern is returned in the global variable _RMATCH, while the global
# variable _RNEXT is set to point at the next positin in string after
# the match, or it is set to "0" if no match is found.
#
# This function is meant to compensate for the lack of sub-expression
# matching capabilities in AWK with respect to sed (\1 ... \9). GNU-AWK
# provides the non-standard gensub() function for this purpose.
# =====================================================================

function _extract(s,p) {

  s = substr(s, _RNEXT)			# move forward

  if (match(s, p)) {
     _RMATCH = substr(s, RSTART, RLENGTH)
     _RNEXT = RSTART + RLENGTH
  }
  else {
     _RMATCH = ""
     _RNEXT = 0
  }

  return _RNEXT
}

