# =====================================================================
# AWK functions for CSA.
#
# Copyright (c) 2001,2002,2003 Carlo Strozzi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License 
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# =====================================================================
# $Id: _rdfprint.awk,v 1.1 2004/08/08 21:15:38 carlo Exp $
# =====================================================================
# void _rdfprint(string s, boolean parse, [string ofile])
#
# Special "print" function for XML/RDF templates. Note that for this
# function to work correctly, the input template must be correctly
# formatted, that is:
#
# 1) "<?xml ....?>" in the very first line on its own. 
# 2) "<html ....>" (case insensitive) on a line of its own.
# 3) RDF begin and end tags on separate lines.
# =====================================================================

function _rdfprint(s,parse,ofile) {

  # Set defaults.
  if (ofile == "") ofile = _STDOUT

  if (parse) s = _xmlencode(s)

  if (ENVIRON["CSA_RPC_FMT"] == "rdf") {
     if (s ~ /^[ \t]*<[Hh][Tt][Mm][Ll][^>]*>[ \t]*$/) _RDFPRINT = 0
     else if (s ~ /^[ \t]*<rdf:RDF /) _RDFPRINT = 1
     else if (s ~ /^[ \t]*<\/rdf:RDF>/) {
	printf("%s",s) > ofile
	_RDFPRINT = 0
	return
     }
  }

  if (_RDFPRINT) printf("%s", s) > ofile
}

